# Generated from activerecord-1.15.5.gem by gem2rpm -*- rpm-spec -*-
%global gem_name activerecord

%global rubyabi 1.9.1

Summary: Implements the ActiveRecord pattern for ORM
Name: rubygem-%{gem_name}
Epoch: 1
Version: 3.0.11
Release: 6%{?dist}
Group: Development/Languages
License: MIT
URL: http://www.rubyonrails.org
Source0: http://rubygems.org/downloads/activerecord-%{version}.gem

# The activerecord gem doesn't ship with the upstream Rakefile
Source1: http://github.com/rails/rails/raw/v%{version}/%{gem_name}/Rakefile

# Also the activerecord gem doesn't ship with the test suite.
# You may check it out like so
# git clone http://github.com/rails/rails.git
# cd rails/activerecord/
# git checkout v3.0.11
# tar czvf activerecord-3.0.11-tests.tgz test/
Source2: activerecord-%{version}-tests.tgz

# Remove a task which breaks the Rakefile due to the gemspec
# not being present in the gem
Patch0: activerecord-rakefile-fix.patch

# Removes code which breaks the test suite due to a
# dependency on a file in the greater rails proj
Patch1: activerecord-tests-fix.patch

Patch2: activerecord-downgrade-dependencies.patch

# Fixes CVE-2012-2661
# https://bugzilla.redhat.com/show_bug.cgi?id=827363
Patch3: activerecord-3.0.13-CVE-2012-2661-predicate-builder-should-not-recurse-for-determining.patch

# Fixes CVE-2012-2695
# https://bugzilla.redhat.com/show_bug.cgi?id=831573
Patch4: activerecord-3.0.15-CVE-2012-2695-additional-fix-for-CVE-2012-2661.patch

# Fixes CVE-2012-6496
# https://bugzilla.redhat.com/show_bug.cgi?id=889649
Patch5: rubygem-activerecord-3.0.18-CVE-2012-6496-dynamic_finder_injection.patch

# CVE-2013-0155
# https://bugzilla.redhat.com/show_bug.cgi?id=892866
Patch6: rubygem-activerecord-3.0.19-CVE-2013-0155-null_array_param.patch

# Fix incompatibilities introduced by CVE-2013-0155 and CVE-2013-0156.
# https://github.com/rails/rails/commit/477f0e798106521865ec7f58026973163a580896
Patch7: rubygem-activerecord-test-3.0.20-Methods-that-return-nil-should-not-be-considered-YAM.patch

# Fixes CVE-2013-0277
# https://bugzilla.redhat.com/show_bug.cgi?id=909633
Patch8: rubygem-activerecord-3.2.12-CVE-2013-0277-serialize.patch

Requires: ruby(abi) = %{rubyabi}
Requires: ruby(rubygems)
Requires: rubygem(activesupport) = %{version}
Requires: rubygem(activemodel)   = %{version}
Requires: rubygem(arel) 
Requires: rubygem(tzinfo) >= 0.3.23
Requires: rubygem(i18n)
BuildRequires: rubygems-devel
BuildRequires: rubygem(rake)
BuildRequires: rubygem(activesupport) = %{version}
BuildRequires: rubygem(activemodel)   = %{version}
BuildRequires: rubygem(sqlite3)
BuildRequires: rubygem(erubis)
BuildRequires: rubygem(mocha)
BuildRequires: rubygem(i18n)
BuildRequires: rubygem(arel)
BuildRequires: rubygem(tzinfo) >= 0.3.23
BuildRequires: rubygem(minitest)
BuildArch: noarch
Provides: rubygem(%{gem_name}) = %{version}

%description
Implements the ActiveRecord pattern (Fowler, PoEAA) for ORM. It ties database
tables and classes together for business objects, like Customer or
Subscription, that can find, save, and destroy themselves without resorting to
manual SQL.

%prep
%setup -q -c -T

# rake test creates debug.log under %%{gem_instdir},
# so let's install gem file under %%{_builddir} first

mkdir -p ./%{gem_dir}
gem install --local --install-dir ./%{gem_dir} \
            --force --rdoc %{SOURCE0}

# move the Rakefile in place
cp %{SOURCE1} .%{gem_instdir}

# move the tests into place
tar xzvf %{SOURCE2} -C .%{gem_instdir}

pushd ./%{gem_instdir}
%patch0 -p0
%patch1 -p0
%patch3 -p2
%patch4 -p2
%patch5 -p2
%patch6 -p2
%patch8 -p2
popd

pushd .%{gem_dir}
%patch2 -p0
popd

# Remove backup files
find ./%{gem_instdir} -type f -name "*~" -delete

# Delete zero-length files
# No! These are needed for rake test
# find ./%{gem_instdir} -type f -size 0c -exec rm -rvf {} \;

# Fix anything executable that does not have a shebang
for file in `find ./%{gem_instdir} -type f -perm /a+x`; do
    [ -z "`head -n 1 $file | grep \"^#!/\"`" ] && chmod -v 644 $file
done

# Find files with a shebang that do not have executable permissions
for file in `find ./%{gem_instdir} -type f ! -perm /a+x -name "*.rb"`; do
    [ ! -z "`head -n 1 $file | grep \"^#!/\"`" ] && chmod -v 755 $file
done

# this file is being marked as a doc, need to remove ruby executable path
# and mark as non-executable
sed -i -e 's/^#!\/usr\/bin\/env ruby//' ./%{gem_instdir}/examples/performance.rb
chmod 0644 ./%{gem_instdir}/examples/performance.rb

%build

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}

%clean
rm -rf %{buildroot}

%check
pushd .%{gem_instdir}

# Test fails with newer mocha. Keep with older one is not solution.
# https://github.com/rails/rails/pull/6046
# https://github.com/rails/rails/commit/2aa7c6d065802cd230a812b8331ee293e4aae0e8
sed -i '590,595 s|^|#|' test/cases/autosave_association_test.rb
sed -i '635,640 s|^|#|' test/cases/autosave_association_test.rb
sed -i '700,708 s|^|#|' test/cases/autosave_association_test.rb

# to prevent a circular dependency w/ actionpack
mv test/cases/session_store/session_test.rb \
     test/cases/session_store/session_test.rb.norun

cat %{PATCH7} | patch -p2

# Only test sqlite3 backend
rake test_sqlite3 --trace
popd

%files
%defattr(-, root, root, -)
%dir %{gem_instdir}
%doc %{gem_instdir}/CHANGELOG
%doc %{gem_instdir}/examples
%{gem_libdir}
%{gem_instdir}/Rakefile
%doc %{gem_instdir}/README.rdoc
%{gem_instdir}/test

%doc %{gem_docdir}
%{gem_cache}
%{gem_spec}

%changelog
* Tue Feb 12 2013 Vít Ondruch <vondruch@redhat.com> - 1:3.0.11-6
- Fix for CVE-2013-0277.

* Thu Jan 10 2013 Vít Ondruch <vondruch@redhat.com> - 1:3.0.11-5
- Fix for CVE-2013-0155.

* Fri Jan 04 2013 Vít Ondruch <vondruch@redhat.com> - 1:3.0.11-4
- Fix for CVE-2012-6496.

* Mon Jun 18 2012 Vít Ondruch <vondruch@redhat.com> - 1:3.0.11-3
- Fix for CVE-2012-2695.

* Mon Jun 04 2012 Vít Ondruch <vondruch@redhat.com> - 1:3.0.11-2
- Fix for CVE-2012-2661.

* Tue Jan 31 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1:3.0.11-1
- Rebuilt for Ruby 1.9.3.
- Update to ActionPack 3.0.11

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:3.0.10-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Aug 22 2011 Vít Ondruch <vondruch@redhat.com> - 1:3.0.10-1
- Update to ActiveRecord 3.0.10

* Mon Jul 04 2011 Vít Ondruch <vondruch@redhat.com> - 1:3.0.9-1
- Update to ActiveRecord 3.0.9

* Fri Mar 25 2011 Vít Ondruch <vondruch@redhat.com> - 1:3.0.5-1
- Updated to ActiveRecord 3.0.5

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:3.0.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Jan 10 2011 Mohammed Morsi <mmorsi@redhat.com> - 1:3.0.3-1
- Update to rails 3

* Wed Sep 08 2010 Mohammed Morsi <mmorsi@redhat.com> - 1:2.3.8-4
- Updated postgres fix to resolve security issue

* Mon Aug 16 2010 Mohammed Morsi <mmorsi@redhat.com> - 1:2.3.8-3
- Included postgres fix (patch also pushed upstream, see rails issue tracker)

* Thu Aug 12 2010 Mohammed Morsi <mmorsi@redhat.com> - 1:2.3.8-2
- Updated patch0 to correctly parse sqlite3 version

* Wed Aug 04 2010 Mohammed Morsi <mmorsi@redhat.com> - 1:2.3.8-1
- Update to 2.3.8

* Thu Jan 28 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1:2.3.5-1
- Update to 2.3.5

* Wed Oct  7 2009 David Lutterkort <lutter@redhat.com> - 1:2.3.4-2
- Bump Epoch to ensure upgrade path from F-11

* Fri Sep 18 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.3.4-1
- Update to 2.3.4
- Enable check

* Sun Jul 26 2009 Jeroen van Meeuwen <j.van.meeuwen@ogd.nl> - 2.3.3-1
- New upstream version

* Mon Mar 16 2009 Jeroen van Meeuwen <j.van.meeuwen@ogd.nl> - 2.3.2-1
- New upstream version

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.2.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Nov 24 2008 Jeroen van Meeuwen <kanarip@fedoraproject.org> - 2.2.2-1
- New upstream version
- Fixed rpmlint errors zero-length files and script-without-shebang

* Thu Nov 20 2008 David Lutterkort <lutter@redhat.com> - 2.1.1-2
- Do not mark lib/ as doc

* Tue Sep 16 2008 David Lutterkort <dlutter@redhat.com> - 2.1.1-1
- New version (fixes CVE-2008-4094)

* Thu Jul 31 2008 Michael Stahnke <stahnma@fedoraproject.org> - 2.1.0-1
- New Upstream

* Tue Apr  8 2008 David Lutterkort <dlutter@redhat.com> - 2.0.2-2
- Fix dependency

* Mon Apr 07 2008 David Lutterkort <dlutter@redhat.com> - 2.0.2-1
- New version

* Mon Dec 10 2007 David Lutterkort <dlutter@redhat.com> - 2.0.1-1
- New version

* Thu Nov 29 2007 David Lutterkort <dlutter@redhat.com> - 1.15.6-1
- New version

* Tue Nov 14 2007 David Lutterkort <dlutter@redhat.com> - 1.15.5-2
- Fix buildroot
- Properly mark docs in geminstdir

* Tue Oct 30 2007 David Lutterkort <dlutter@redhat.com> - 1.15.5-1
- Initial package
